package com.gic.cloud.data.hook.service;

import com.alibaba.dubbo.common.utils.StringUtils;
import com.ctrip.framework.apollo.Config;
import com.ctrip.framework.apollo.ConfigService;
import com.gic.cloud.data.hook.api.dto.QueryDataType;
import com.gic.cloud.data.hook.api.entity.FlatQueryCondition;
import com.gic.cloud.data.hook.service.impl.FreeQueryServiceImpl;
import com.gic.data.shield.SdkEnv;
import com.gic.data.shield.decrypt.DataDecryptionClient;
import com.gic.data.shield.exception.DecryptException;
import org.springframework.stereotype.Service;

import java.util.List;

public class DecryptUtils {

	private static DataDecryptionClient decryptionClient = null;

	private static DecryptUtils instance = null;

	private  static  String encryptSalt = "YxFAqwocNUXdpteE";


	static {
		DataDecryptionClient.setEnv(SdkEnv.PROD);
		decryptionClient = new DataDecryptionClient();
	}

	private DecryptUtils() {
		instance = this;
//		DataDecryptionClient.setEnv(SdkEnv.DEV);
//		decryptionClient = new DataDecryptionClient();
	}


	public static DecryptUtils getInstance() {
		//DataDecryptionClient.setEnv(SdkEnv.DEV);
		//DataDecryptionClient.setEnv(SdkEnv.DEV);
		if (instance == null) instance = new DecryptUtils();
		return instance;
	}

	public static String decrypt(String encryptString) {
		try {
			String result = decryptionClient.decrypt(encryptString);
			if(org.apache.commons.lang.StringUtils.isNotBlank(result)){
				if(result.contains("E0")){
					return result+"\t";
				}
			}
			return result;
		} catch (DecryptException e) {
			e.printStackTrace();
			return "";
		}
	}

	public static String decrypt(String enterpriseId,String encryptString) {
		if (DecryptUtils.checkDecrypt(enterpriseId)){
			return DecryptUtils.decrypt(encryptString);
		}else{
			if (AESEncryptUtils.isEncrypted(encryptString)) {
				return AESEncryptUtils.decrypt(encryptString,encryptSalt);
			}
			return encryptString;
		}
	}

	public static String dataSecurityProcessUserName(String userName){
		if(StringUtils.isBlank(userName)){
			return userName;
		}
		StringBuffer stringBuffer = new StringBuffer();
		stringBuffer.append(userName.charAt(0)).append("**");
		return stringBuffer.toString();
	}

	public static boolean isName(String columnName, List<FlatQueryCondition> allFields){
		if(StringUtils.isBlank(columnName)){
			return false;
		}
		for(FlatQueryCondition condition : allFields){
			if(condition.getFieldMark().equals(columnName)){
				if(FilterFieldUtils.FILETERS_USER_NAME.contains(condition.getFieldName())){
					return true;
				}
			}
		}
		return false;
	}

	/**
	 * 是否需要解密
	 * @param enterpriseId
	 * @return
	 */
	public static boolean checkDecrypt(String enterpriseId) {
		Config appConfig = ConfigService.getAppConfig();
		String entIds = appConfig.getProperty("decrypt-enterprise", "1");
		if (entIds.equals("-1")) {
			return false;
		}else if (entIds.equals("1")) {
			return true;
		}else if (entIds.contains(enterpriseId)) {
			return false;
		}else{
			return true;
		}
	}

	/**
	 * 脱敏
	 * @param queryDataType
	 * @param columnVal
	 * @param condition
	 * @return
	 */
	public static String encryptionDeal(int queryDataType,String columnVal,FlatQueryCondition condition){
		if(queryDataType == QueryDataType.FULL){
			return columnVal;
		} else {
			if(condition.getEnableEncrypt()) {
				return "******";
			}else if (FilterFieldUtils.FILETERS_USER_NAME.contains(condition.getFieldName())) {
				return DecryptUtils.dataSecurityProcessUserName(columnVal);
			} else {
				return columnVal;
			}
		}
	}


}
